//+------------------------------------------------------------------+
//|                                      CanvasPolylineShadow1_3.mq5 |
//|                              Copyright  2015, Vladimir Karputov |
//|                                           http://wmua.ru/slesar/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2015, Vladimir Karputov"
#property link      "http://wmua.ru/slesar/"
#property version   "1.3"
#property description "Drawing primitives with antialiasing"
//--- show the window of input parameters when launching the script
#property script_show_inputs
//+------------------------------------------------------------------+
//| V1.3 Draw: parabola, polygon, polyline, triangle, circle.        |
//+------------------------------------------------------------------+
#include <Canvas\Canvas.mqh>
//---
int            Width=-1;
int            Height=-1;
double         focus=51.3;
//+------------------------------------------------------------------+
//| inputs                                                           |
//+------------------------------------------------------------------+
input color colr=clrRed;
input color clr_Circle=clrBlue;
//---
uchar alpha=0;                //alpha channel managing color transparency
int   can_width,can_height;   //
int   can_x1,can_y1,can_x2,can_y2,can_y3,can_x3;   //coordinates
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
int OnStart(void)
  {
//--- arrays for method PixelSetAA
   double double_x[],double_y[];
//--- arrays for method LineAA, PolylineAA, PolygonAA, TriangleAA, CircleAA
   int int_x[],int_y[];
   Width=ChartWidthInPixels();
   Height=ChartHeightInPixelsGet()-50;
//---
   can_width=Width/3;   can_height=Height;
   can_x1=0;            can_y1=0;
   can_x2=can_width;    can_y2=0;
   can_x3=can_width*2;  can_y3=0;
   
//--- create canvas
   CCanvas canvas_XRGB_NOALPHA,canvas_ARGB_RAW,canvas_XARGB_NORMALIZE;
   if(!canvas_XRGB_NOALPHA.CreateBitmapLabel("canvas_XRGB_NOALPHA",can_x1,can_y1,can_width,can_height,COLOR_FORMAT_XRGB_NOALPHA))
     {
      Print("Error creating canvas: ",GetLastError());
      return(-1);
     }
   canvas_XRGB_NOALPHA.Erase(ColorToARGB(colr,alpha));
   canvas_XRGB_NOALPHA.TextOut((can_width)/2,can_height/2,"canvas_XRGB_NOALPHA",ColorToARGB(clrBlue,255),TA_CENTER|TA_VCENTER);
   canvas_XRGB_NOALPHA.FillCircle((can_width)/2,can_height/2+50,25,ColorToARGB(clr_Circle,alpha));
   canvas_XRGB_NOALPHA.Update();
   
//---
   if(!canvas_ARGB_RAW.CreateBitmapLabel("canvas_ARGB_RAW",can_x2,can_y2,can_width,can_height,COLOR_FORMAT_ARGB_RAW))
     {
      Print("Error creating canvas: ",GetLastError());
      return(-1);
     }
   canvas_ARGB_RAW.Erase(ColorToARGB(colr,alpha)); //clrNONE,0));
   canvas_ARGB_RAW.TextOut((can_width)/2,can_height/2,"canvas_ARGB_RAW",ColorToARGB(clrBlue,255),TA_CENTER|TA_VCENTER);
   canvas_ARGB_RAW.FillCircle((can_width)/2,can_height/2+50,25,ColorToARGB(clr_Circle,alpha));
   canvas_ARGB_RAW.Update();
   
//---
   if(!canvas_XARGB_NORMALIZE.CreateBitmapLabel("canvas_XARGB_NORMALIZE",can_x3,can_y3,can_width,can_height,COLOR_FORMAT_ARGB_NORMALIZE))
     {
      Print("Error creating canvas: ",GetLastError());
      return(-1);
     }
   canvas_XARGB_NORMALIZE.Erase(ColorToARGB(colr,alpha));
   canvas_XARGB_NORMALIZE.TextOut((can_width)/2,can_height/2,"canvas_XARGB_NORMALIZE",ColorToARGB(clrBlue,255),TA_CENTER|TA_VCENTER);
   canvas_XARGB_NORMALIZE.FillCircle((can_width)/2,can_height/2+50,25,ColorToARGB(clr_Circle,alpha));
   canvas_XARGB_NORMALIZE.Update();
//--- 
/*
   ArrayResize(double_x,Width);
   ArrayResize(double_y,Width);
   ArrayResize(int_x,Width);
   ArrayResize(int_y,Width);
// Offset on an axis of "Y"
   int p=Height/2;
   uint clr_no_alfa=ColorToARGB(clrRed,255);
   uint clr_alfa0=ColorToARGB(clrRed,190);
   uint clr_alfa1=ColorToARGB(clrRed,110);
   uint clr_alfa2=ColorToARGB(clrRed,30);
   int thickness=3;
//--- filling an double array
   for(int i=0;i<Width;i++)
     {
      static double increment;
      double_x[i]=increment;
      double_y[i]=MathSqrt(focus*double_x[i]);
      increment=increment+0.4;
     }
//--- filling an int array
   for(int i=0;i<Width;i++)
     {
      int_x[i]=i+9;
      int_y[i]=int(MathSqrt(focus*int_x[i]));
     }
//--- draw pixels
   if(PixelSet_AA)
     {
      for(int i=0;i<Width;i++)
        {
         for(int count=0;count<thickness;count++)
           {
            canvas.PixelSetAA(double_x[i],p+double_y[i]-count,clr_no_alfa);
            canvas.PixelSetAA(double_x[i],p-double_y[i]-count,clr_no_alfa);
           }
        }
     }
//--- draw polyline
   if(Polyline_AA)
     {
      canvas.PolylineAA(int_x,int_y,clr_no_alfa,STYLE_SOLID);
      //canvas.PolylineAA(x,y[i],clr_no_alfa);
     }
/*
//--- Drawing shadows
   canvas.PixelSetAA(x[i],p+y[i],clr_alfa0);
   canvas.PixelSetAA(x[i],p-y[i],clr_alfa0);
   canvas.PixelSetAA(x[i],p+y[i]+1,clr_alfa0);
   canvas.PixelSetAA(x[i],p-y[i]+1,clr_alfa0);
   canvas.PixelSetAA(x[i],p+y[i]+2,clr_alfa1);
   canvas.PixelSetAA(x[i],p-y[i]+2,clr_alfa1);
   canvas.PixelSetAA(x[i],p+y[i]+3,clr_alfa1);
   canvas.PixelSetAA(x[i],p-y[i]+3,clr_alfa1);
   canvas.PixelSetAA(x[i],p+y[i]+4,clr_alfa2);
   canvas.PixelSetAA(x[i],p-y[i]+4,clr_alfa2);
   canvas.PixelSetAA(x[i],p+y[i]+4,clr_alfa2);
   canvas.PixelSetAA(x[i],p-y[i]+4,clr_alfa2);
*/
/*
   canvas.Update();
*/
   uchar transparent=0;
   for(transparent=0;transparent<255;transparent++)
     {
      canvas_XRGB_NOALPHA.TransparentLevelSet(transparent);
      canvas_XRGB_NOALPHA.Update();
      canvas_ARGB_RAW.TransparentLevelSet(transparent);
      canvas_ARGB_RAW.Update();
      canvas_XARGB_NORMALIZE.TransparentLevelSet(transparent);
      canvas_XARGB_NORMALIZE.Update();
      Sleep(10);
     }
   canvas_XRGB_NOALPHA.TransparentLevelSet(transparent);
//canvas_XRGB_NOALPHA.FillCircle(Width/3/2,Height/2+75,25,ColorToARGB(clr_Circle,alpha));
   canvas_XRGB_NOALPHA.Update();
   canvas_ARGB_RAW.TransparentLevelSet(transparent);
//canvas_ARGB_RAW.FillCircle((Width/3*2-Width/3)/2,Height/2+75,25,ColorToARGB(clr_Circle,alpha));
   canvas_ARGB_RAW.Update();
   canvas_XARGB_NORMALIZE.TransparentLevelSet(transparent);
//canvas_XARGB_NORMALIZE.FillCircle((Width-Width/3*2)/2,Height/2+75,25,ColorToARGB(clr_Circle,alpha));
   canvas_XARGB_NORMALIZE.Update();
   Sleep(3000);
//--- finish
   ObjectDelete(0,"canvas_XRGB_NOALPHA");
   ObjectDelete(0,"canvas_ARGB_RAW");
   ObjectDelete(0,"canvas_XARGB_NORMALIZE");
   canvas_XRGB_NOALPHA.Destroy();
   canvas_ARGB_RAW.Destroy();
   canvas_XARGB_NORMALIZE.Destroy();
   return(0);
  }
//+------------------------------------------------------------------+
//| Random RGB color                                                 |
//+------------------------------------------------------------------+
uint RandomRGB(void)
  {
   return(XRGB(rand()%255,rand()%255,rand()%255));
  }
//+------------------------------------------------------------------+
//| Gets the width of chart (in pixels)                              |
//+------------------------------------------------------------------+
int ChartWidthInPixels(const long chart_ID=0)
  {
//--- prepare the variable to get the property value
   long result=-1;
//--- reset the error value
   ResetLastError();
//--- receive the property value
   if(!ChartGetInteger(chart_ID,CHART_WIDTH_IN_PIXELS,0,result))
     {
      //--- display the error message in Experts journal
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//--- return the value of the chart property
   return((int)result);
  }
//+------------------------------------------------------------------+
//| Gets the height of chart (in pixels)                             |
//+------------------------------------------------------------------+
int ChartHeightInPixelsGet(const long chart_ID=0,const int sub_window=0)
  {
//--- prepare the variable to get the property value
   long result=-1;
//--- reset the error value
   ResetLastError();
//--- receive the property value
   if(!ChartGetInteger(chart_ID,CHART_HEIGHT_IN_PIXELS,sub_window,result))
     {
      //--- display the error message in Experts journal
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//--- return the value of the chart property
   return((int)result);
  }
//+------------------------------------------------------------------+
